#from panda3d.core import loadPrcFileData
#loadPrcFileData("", "want-directtools #t")
#loadPrcFileData("", "want-tk #t")

import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject 
from pandac.PandaModules import *

from input_control import Input


class World():
	def __init__(self):
		self.input_control = Input()
		self.input_control.keymap = Input()
		print base.win.movePointer(0, 0 ,0)
		base.disableMouse()
		self.x = 0
		##loadModel
		self.node = NodePath('player')
		self.node.reparentTo(render)
		base.camera.reparentTo(self.node)
		self.jar = loader.loadModel("assets/chair")
		self.kar = loader.loadModel("assets/chair")
		self.lar = loader.loadModel("assets/chair")
		self.plane = loader.loadModel("assets/plane")
		self.node.setPos(0,0,2)
		
		##Reparent
		self.plane.reparentTo(render)
		self.jar.reparentTo(render)
		self.kar.reparentTo(render)
		self.lar.reparentTo(render)
		
		## Render attribute
		self.jar.setColor(1, 0, 0)
		self.kar.setColor(0, 1, 0)
		self.lar.setColor(0, 0, 1)
		
		##Model transform
		self.jar.setPos(-5, 0, 2)
		self.kar.setPos(0, 0, 2)
		self.lar.setPos(5, 0, 5)
		self.plane.setHpr(0, 0, 0)
		pl = base.cam.node().getLens()
		pl.setFov(70)
		base.cam.node().setLens(pl)
		
		#base.camera.setHpr(0, 270, 0)
		
		##Cameras
		
		##Collisions
		
		#Collisions jar
		self.collision_node = CollisionNode("cnode_1")
		self.collision_sphere = CollisionSphere(0, 0, 0, 1)
		self.collision_node.addSolid(self.collision_sphere)
		self.collision_node_path = render.attachNewNode(self.collision_node)
		self.collision_node_path.reparentTo(self.jar)
		self.collision_node_path.show()
		
		self.cHan_pusher = CollisionHandlerPusher()
		self.cHan_pusher.addCollider(self.collision_node_path, self.jar)

		#Kar
		self.collision_node_2 = CollisionNode("cnode_2")
		self.collision_sphere_2 = CollisionSphere(0, 0, 0, 1)
		self.collision_node_2.addSolid(self.collision_sphere_2)
		self.collision_node_path_2 = render.attachNewNode(self.collision_node_2)
		self.collision_node_path_2.reparentTo(self.kar)
		self.collision_node_path_2.show()

		self.cHan_pusher_2 = CollisionHandlerPusher()
		self.cHan_pusher_2.addCollider(self.collision_node_path_2, self.kar)
		
		#lar
		self.collision_node_3 = CollisionNode("cnode_3")
		self.collision_sphere_3 = CollisionSphere(0, 0, 0, 1)
		self.collision_node_3.addSolid(self.collision_sphere_3)
		self.collision_node_path_3 = render.attachNewNode(self.collision_node_3)
		self.collision_node_path_3.reparentTo(self.lar)
		self.collision_node_path_3.show()
		
		
		self.cHan_pusher_3 = CollisionHandlerPusher()
		self.cHan_pusher_3.addCollider(self.collision_node_path_3, self.lar)
		
		#Floor!
		self.collision_node_3.addSolid(CollisionRay(0, 0, 0, 0 ,0, -1))
		self.collision_node_3.setFromCollideMask(BitMask32.bit(0))
		self.collision_node_3.setIntoCollideMask(BitMask32.allOff())
		
		self.lifter = CollisionHandlerFloor()
		self.lifter.addCollider(self.collision_node_path_3, self.lar)
		
		#The Traverser!

		self.cTrav = CollisionTraverser()
		base.cTrav = self.cTrav
		self.cTrav.traverse(render)

		self.cTrav.addCollider(self.collision_node_path, self.cHan_pusher)
		self.cTrav.addCollider(self.collision_node_path_3, self.cHan_pusher_3)
		self.cTrav.addCollider(self.collision_node_path_2, self.cHan_pusher_2)		
		
		#Tasks
		taskMgr.add(self.vase_control, 'vase_control')
		taskMgr.add(self.mouseUpdate, 'update mouse')
		#taskMgr.doMethodLater(1, self.task, 'thing')
	def task(self, task):
		print taskMgr
		return task.again

	def mouseUpdate(self,task):
		self.centerx =  base.win.getProperties().getXSize()/2
		self.centery =  base.win.getProperties().getYSize()/2
		md = base.win.getPointer(0)
		x = md.getX()
		y = md.getY()
		if base.win.movePointer(0, base.win.getXSize()/2, base.win.getYSize()/2):
			self.node.setH(self.node.getH() -  (x - base.win.getXSize()/2)*0.1)
			self.node.setP(self.node.getP() - (y - base.win.getYSize()/2)*0.1)
			print "x = %d" % x
			print "y = %d" % y
			print "h = %d" % self.node.getH()
			print "p = %d" %self.node.getH()
		return task.cont
		
	def vase_control(self, task):
		dt = globalClock.getDt()
		#print dt
		if self.input_control.keymap['f1'] == True:
			base.camera.setPos(0, 0, 30)
			base.camera.setHpr(0, 270, 0)
			if self.input_control.keymap['j'] == True:
				if self.input_control.keymap['w'] == True:
					self.jar.setHpr(90, 0, 0)
					self.jar.setX(self.jar, 8 * dt)
				if self.input_control.keymap['a'] == True:
					self.jar.setHpr(180, 0, 0)
					self.jar.setX(self.jar, 8 * dt)
				if self.input_control.keymap['s'] == True:
					self.jar.setHpr(270, 0, 0)
					self.jar.setX(self.jar, 8 * dt)
				if self.input_control.keymap['d'] == True:
					self.jar.setHpr(0, 0, 0)
					self.jar.setX(self.jar, 8 * dt)
			if self.input_control.keymap['k'] == True:
				if self.input_control.keymap['w'] == True:
					self.kar.setHpr(90, 0, 0)
					self.kar.setX(self.kar, 8 * dt)
				if self.input_control.keymap['a'] == True:
					self.kar.setHpr(180, 0, 0)
					self.kar.setX(self.kar, 8 * dt)
				if self.input_control.keymap['s'] == True:
					self.kar.setHpr(270, 0, 0)
					self.kar.setX(self.kar , 8 * dt)
				if self.input_control.keymap['d'] == True:
					self.kar .setHpr(0, 0, 0)
					self.kar .setX(self.kar , 8 * dt)
			if self.input_control.keymap['l'] == True:
				if self.input_control.keymap['w'] == True:
					self.lar .setHpr(90, 0, 0)
					self.lar .setX(self.lar , 8 * dt)
				if self.input_control.keymap['a'] == True:
					self.lar .setHpr(180, 0, 0)
					self.lar .setX(self.lar , 8 * dt)
				if self.input_control.keymap['s'] == True:
					self.lar .setHpr(270, 0, 0)
					self.lar .setZ(self.lar , -8 * dt)
				if self.input_control.keymap['d'] == True:
					self.lar .setHpr(0, 0, 0)
					self.lar .setX(self.lar , 8 * dt)
		if self.input_control.keymap['f2'] == True:
			##base.camera.setHpr(0, 0, 0)
			##if base.mouseWatcherNode.hasMouse() == True:
				##mpos = base.mouseWatcherNode.getMouse()
				##base.camera.setP(mpos.getY() * 360)
				##base.camera.setH(mpos.getX() * -360)
				
			if self.input_control.keymap['w'] == True:
				self.node.setY(self.node, 8 * dt)
			if self.input_control.keymap['a'] == True:
				self.node.setX(self.node, -8 * dt)
			if self.input_control.keymap['s'] == True:
				self.node.setY(self.node, -8 * dt)
			if self.input_control.keymap['d'] == True:
				self.node.setX(self.node, 8 * dt)		
				
		return task.cont
		
				 

w = World()

run()